Class ItemReplacerMPW2: EventHandler
{
 Class<Inventory> StartItem;

 static const string StartingWeap[] = {"Melee","Handgun","Plasma Handgun","DemonTechPistol","TangoFist","TangoPistol"};
 static const string StartingAmmo[] = {"BulletMag","DemonAmmo","Clip"};

 static const string MPWMons[] = {"MPWTangoPlasmaZombieDropsClip",
 "MPWTangoShotgunGuy",
 "MPWTangoChaingunGuy",
 "MPWTangoImp",
 "MPWTangoMechaDemon",
 "MPWTangoMechaSpectre",
 "MPWTangoLostSoul",
 "MPWTangoCacodemon",
 "TangoPainElementalSpawner",
 "MPWTangoPainElemental",
 "MPWTangoFusionite",
 "MPWTangoBehemoth",
 "TangoDraugrSpawner",
 "MPWTangoDraugr",
 "TangoHellKnightSpawner",
 "MPWTangoHellKnight",
 "TangoBaronOfHellSpawner",
 "MPWTangoBaronOfHell",
 "MPWTangoExile",
 "TangoBaronOfHellSpawner",
 "MPWTangoSpiderMastermindDropScrapGunCache",
 "MPWTangoCyberdemon",
 "TangoDeadPlasmaZombie",
 "TangoDeadShotgunGuy",
 "TangoDeadImp",
 "TangoDeadMechaDemon",
 "TangoDeadCacodemon",
 "TangoNewBlood",
 "TangoNewBloodSplatter"};

 static const string MPWWeap[] = {"TangoChainsaw","TangoShotgun","TangoSuperShotgun","TangoAssaultRifle",
				  "TangoRocketLauncher","TangoPlasmaRifle","TangoBFG9000"};

 static const string MPWAmmo[] = {"TangoBackpack","TangoShell","TangoShellBox","TangoBulletClip",
	"TangoBulletBox","TangoRocketAmmo","TangoRocketBox","TangoCell","TangoCellPack","TBulletPuff"};

 
 Override void CheckReplacement (ReplaceEvent e)
  {
   if(!whichWad && !whichMod) {return;}

   if(whichWad && whichMod != 0) {Console.Printf("You are breaking Tonyn's law and making a mess"); return;}

   if(whichWad == 1)
    {
     if(keep_WadStuff == 1)
      {
       switch(e.Replacee.GetClassName())
        {
 	 Case 'Zombieman': e.Replacement = MPWMons[0]; break; 
	 Case 'ShotgunGuy': e.Replacement = MPWMons[1]; break;
	 Case 'ChaingunGuy': e.Replacement = MPWMons[2]; break;
	 Case 'DoomImp': e.Replacement = MPWMons[3]; break;
	 Case 'Demon': e.Replacement = MPWMons[4]; break;
	 Case 'Spectre': e.Replacement = MPWMons[5]; break;
	 Case 'LostSoul': e.Replacement = MPWMons[6]; break;
	 Case 'Cacodemon': e.Replacement = MPWMons[7]; break;

	 Case 'PainElemental': 
	  if(MPW_hardrandom) {e.Replacement = MPWMons[8];}
	  else {e.Replacement = MPWMons[9];}; break;

	 Case 'Arachnotron': e.Replacement = MPWMons[10]; break;
	 Case 'Fatso': e.Replacement = MPWMons[11]; break;

	 Case 'Revenant': 
	  if(MPW_hardrandom) {e.Replacement = MPWMons[12];}
	  else {e.Replacement = MPWMons[13];}; break;

	 Case 'HellKnight':  
	  if(MPW_hardrandom) {e.Replacement = MPWMons[14];}
	  else {e.Replacement = MPWMons[15];}; break;

	 Case 'BaronofHell': 
	  if(MPW_hardrandom) {e.Replacement = MPWMons[16];}
	  else {e.Replacement = MPWMons[17];}; break;

	 Case 'Archvile': e.Replacement = MPWMons[18]; break;

	 Case 'SpiderMastermind': 
	  if(MPW_hardrandom) {e.Replacement = MPWMons[19];}
	  else {e.Replacement = MPWMons[20];}; break;

	 Case 'CyberDemon': e.Replacement = MPWMons[21]; break;

	 Case 'DeadZombieMan': e.Replacement = MPWMons[22]; break;
	 Case 'DeadShotgunGuy': e.Replacement = MPWMons[23]; break;
	 Case 'DeadDoomImp': e.Replacement = MPWMons[24]; break;
	 Case 'DeadDemon': e.Replacement = MPWMons[25]; break;
	 Case 'DeadCacodemon': e.Replacement = MPWMons[26]; break;

	 Case 'Blood': e.Replacement = MPWMons[27]; break;
	 Case 'BloodSplatter': e.Replacement = MPWMons[28]; break;
        }
      }


     else if(keep_WadStuff == 2)
      {
       switch(e.Replacee.GetClassName())
        {
	 Case 'Chainsaw':	e.Replacement = MPWWeap[0]; break;
	 Case 'Shotgun': 	e.Replacement = MPWWeap[1]; break;
	 Case 'SuperShotgun': 	e.Replacement = MPWWeap[2]; break;
	 Case 'Chaingun': 	e.Replacement = MPWWeap[3]; break;
	 Case 'RocketLauncher': e.Replacement = MPWWeap[4]; break;
	 Case 'PlasmaRifle': 	e.Replacement = MPWWeap[5]; break;
	 Case 'BFG9000': 	e.Replacement = MPWWeap[6]; break;

	 Case 'Clip':    	e.Replacement = MPWAmmo[3]; break;
	 Case 'Clipbox': 	e.Replacement = MPWAmmo[4]; break;
	 Case 'Shell':   	e.Replacement = MPWAmmo[1]; break;
	 Case 'Shellbox': 	e.Replacement = MPWAmmo[2]; break;
	 Case 'Rocketammo': 	e.Replacement = MPWAmmo[5]; break;
	 Case 'RocketBox': 	e.Replacement = MPWAmmo[6]; break;
	 Case 'Cell':    	e.Replacement = MPWAmmo[7]; break;
	 Case 'CellPack': 	e.Replacement = MPWAmmo[8]; break;

	 Case 'BulletPuff': 	e.Replacement = MPWAmmo[9]; break;
        }
      }
    }

  e.IsFinal = true;
 }


//this fixes starting items in case player want to keep Tango's weapons
 Override void PlayerEntered(PlayerEvent e)
 {
  if(whichWad != 1) {return;}
  PlayerStart(e);
 }


 Override void PlayerRespawned(PlayerEvent e)
 {
  if(whichWad != 1) {return;}
  PlayerStart(e);
 }

 void PlayerStart(PlayerEvent e)
 {
  let player = players[e.PlayerNumber].mo;
  int x=0; int y=0;

  while(y<3)
   {
    StartItem = (Class<Inventory>)(StartingAmmo[y]);
    
    if(StartItem) { player.TakeInventory(StartItem,20);}
    y++;
   }

  while(x<6)
   {
    StartItem = (Class<Inventory>)(StartingWeap[x]);
    
    if(StartItem)
     {
      player.TakeInventory(StartItem,1);

      if( keep_WadStuff!=2 &&  x<4 ) {player.GiveInventory(StartItem,1);}
      else if( keep_WadStuff==2  && x>=4 ) {player.GiveInventory(StartItem,1);}
     }
    x++;
   }

 }
}
